#! /usr/local/bin/python

#Load modules
import pygtk, gtk, gobject, ConfigParser
from locale import getpreferredencoding
from pango import ELLIPSIZE_END
from os import stat, environ, path, listdir
from time import time
from sys import argv
from platform import system as systemname

#Import windows
import winscan, winpreferences, winupdate, wineventlog, winabout

#Execution time
timen = time()

#Load psyco (if exists)
try:
    import psyco
    psyco.full()
except:
    print 'Warning:: Failed to load Psyco.. skipped'
else:
    print 'Psyco successfully imported'
    

class indexWindow:
    
    def __init__(self):
        print 'Loading configuration..',
        
        #Create configparser object
        self.globalconfig = ConfigParser.ConfigParser()
        self.globalconfig.read('etc/gconfig.cfg')
        
        print 'OK'
        print 'Loading definitions..',
        
        #Create configparser object
        self.defconfig = ConfigParser.ConfigParser()
        self.defconfig.read('etc/black_list.cfg')
        
        print 'OK'
        
        #Assign main variables
        self.nametheme = 'icons/%s' % self.globalconfig.get('USER','theme') #won't be edited
        
        print 'Loading language file...',
    
        #Load language file
        self.languageconfig = ConfigParser.ConfigParser()
        self.languageconfig.read('etc/lang/%s/langconf.cfg' % self.globalconfig.get('USER','language_id'))

        #Convert all strings to pygtk-utf8 encoding
        for section in self.languageconfig.sections():
            for option in self.languageconfig.options(section):
                self.languageconfig.set(section, option, self.languageconfig.get(section, option).decode(getpreferredencoding()).encode("utf-8"))

        print 'OK'
        
        #Load icons
        self.nixoryicf = gtk.IconFactory()
        self.nixoryicf.add(gtk.STOCK_DIALOG_INFO, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/info_big.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_DIALOG_ERROR, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/error_big.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_OK, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_NO, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_YES, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_APPLY, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/apply.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_CLOSE, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_CANCEL, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/deny.png" % self.nametheme)))
        self.nixoryicf.add(gtk.STOCK_DIALOG_WARNING, gtk.IconSet(gtk.gdk.pixbuf_new_from_file("%s/warning.png" % self.nametheme)))
        self.nixoryicf.add_default()
        
        #Monitorate configuration files
        self.lstime = stat('etc/gconfig.cfg').st_mtime
        self.lstime2 = stat('etc/black_list.cfg').st_mtime

        #If first running, search for cookie.txt
        if not int(self.globalconfig.get('PREFERENCES', 'search_ex')) or '-auto' in argv:
          try:
            #Open environment variables
	    sysname = systemname()
	    if sysname == 'Windows':
	       pathto = environ.get('APPDATA') + '/Mozilla/Firefox/Profiles/'
               prof = listdir(pathto)
            elif sysname == 'Linux':
	       pathto = environ.get('HOME') + '/.mozilla/firefox/'
	       prof = listdir(environ.get('HOME') + '/.mozilla/firefox/')
            #Add profiles detected
            for profile in prof:
              selected = pathto + str(profile) + '/cookies.txt'
              if not path.exists(selected):
                pass
              elif not "HTTP Cookie File" in open(selected, 'r').readline():
                pass
              else:
                  self.globalconfig.set('USER', 'profiles', str(path.basename(path.dirname(selected)) + '|' + str(selected) + '||'))
                  print 'Detected profile: ' + str(selected)

            #Set false
            self.globalconfig.set('PREFERENCES', 'search_ex', '1')
            self.globalconfig.write(open('etc/gconfig.cfg','w'))

        

          except:
              pass

        #Disable automated search
        #self.globalconfig.set('PREFERENCES', 'search_ex', 1)

        #Show main window
        self.win_main()
        
    def win_main(self):
        #Construct main window
        win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        win.connect("delete_event",self.delete_event)
        win.connect("destroy",self.destroyw)
        win.set_position(gtk.WIN_POS_CENTER)
        win.set_default_size(550, 316)
        win.set_resizable(True)
        win.set_title('Nixory')
        gtk.window_set_default_icon_from_file('%s/nixory_icon.png' % self.nametheme)
        win.connect("focus-in-event", self.event_occ, self)
                
        #Table container
        indextable = gtk.Table(4, 3, False)
        
        #HBox container
        buttonsbox = gtk.HBox(True, 0)
        
        #Tree liststore
        global liststore
        liststore = gtk.ListStore(gtk.gdk.Pixbuf, int, str)
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/scans.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_scans')), self.languageconfig.get('MAINWINDOW','index_scan')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/found_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_found_obj')), self.languageconfig.get('MAINWINDOW','index_found_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/removed_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_removed_obj')), self.languageconfig.get('MAINWINDOW','index_removed_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/hfound_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_hfound_obj')), self.languageconfig.get('MAINWINDOW','index_hfound_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/mfound_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_mfound_obj')), self.languageconfig.get('MAINWINDOW','index_mfound_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/lfound_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_lfound_obj')), self.languageconfig.get('MAINWINDOW','index_lfound_obj')])
        liststore.append([gtk.gdk.pixbuf_new_from_file("%s/ifound_obj.png" % self.nametheme), int(self.globalconfig.get('GENERAL','num_ifound_obj')), self.languageconfig.get('MAINWINDOW','index_ifound_obj')])
        
        #TreeView
	treeview = gtk.TreeView(liststore)
	treeview.set_rules_hint(True)
	
	#TreeViewColums
	columnint = gtk.TreeViewColumn(' '*12)
	columnint.set_resizable(True)
	columnstr = gtk.TreeViewColumn(self.languageconfig.get('MAINWINDOW','index_name'))
	
	#Append columns
	treeview.append_column(columnint)
	treeview.append_column(columnstr)
	
	#Cellrenderers
	cellpix = gtk.CellRendererPixbuf()
	cellint = gtk.CellRendererText()
	cellstr = gtk.CellRendererText()
        cellstr.set_property('ellipsize-set', True)
        cellstr.set_property('ellipsize', ELLIPSIZE_END)
	
	#Add cell renderers
	columnint.pack_start(cellpix, True)
	columnint.pack_start(cellint, True)
	columnstr.pack_start(cellstr, True)
	
	#Set attributes
	columnint.set_attributes(cellpix, pixbuf=0)
	columnint.set_attributes(cellint, text=1)
	columnstr.set_attributes(cellstr, text=2)
	cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
	
	#Status Bar
        global nixstatusbar
	nixstatusbar = gtk.Statusbar()
	nixstatusbar.push(1, (':'*3) + self.languageconfig.get('MAINWINDOW','database_status') + ' ' + self.defconfig.get('INFO','version') + ' (' + self.defconfig.get('INFO','date') + ')')
        
	#Box button quit
	quitbox = gtk.HBox(False, 0)
	quitimage = gtk.Image()
	quitimage.set_from_file('%s/quit.png' % self.nametheme)
	quitlab = gtk.Label('   %s' % self.languageconfig.get('MAINWINDOW','quit_label'))
	quitbox.pack_start(quitimage, False, 1)
	quitbox.pack_start(quitlab, True, 1)
	quitbut = gtk.Button()
	quitbut.add(quitbox)
	quitbut.connect('clicked', self.destroyw, win)
	
	#Button Scan
	scanbox = gtk.HBox(False, 0)
	scanimage = gtk.Image()
	scanimage.set_from_file('%s/scan_now.png' % self.nametheme)
	scanlab = gtk.Label('  %s' % self.languageconfig.get('MAINWINDOW','scan_label'))
	scanbox.pack_start(scanimage, False)
	scanbox.pack_start(scanlab, False)
	scanbut = gtk.Button()
	scanbut.add(scanbox)
	scanbut.connect('clicked', winscan.winshow, self.destroyw, self.delete_event, self.languageconfig, self.globalconfig, self.defconfig, self.nametheme, win)

	#Button Update
	updatebox = gtk.HBox(False, 0)
	updateimage = gtk.Image()
	updateimage.set_from_file('%s/connect.png' % self.nametheme)
	updatelab = gtk.Label('  %s' % self.languageconfig.get('MAINWINDOW','update_label'))
	updatebox.pack_start(updateimage, False)
	updatebox.pack_start(updatelab, False)
	updatebut = gtk.Button()
	updatebut.add(updatebox)
	updatebut.connect('clicked', winupdate.winshow, self.destroyw, self.delete_event, self.languageconfig, self.globalconfig, self.nametheme, win, self.defconfig)        

	#Label
	status = gtk.Label()
        status.set_text(self.languageconfig.get('MAINWINDOW','status_label'))
	
	#box packstart
	buttonsbox.pack_start(quitbut, True, True)
	buttonsbox.pack_start(scanbut, True, True)
	buttonsbox.pack_start(updatebut, True, True)
	
	#File menu
	file_menu = gtk.Menu()
	
        #Add quit item
	quit_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_file_quit'))
        image = gtk.Image()
        image.set_from_file('%s/quit.png' % self.nametheme)
        quit_item.set_image(image)
	quit_item.connect_object('activate', self.destroyw, win)
	
	file_menu.append(quit_item)
	
	#Options menu
	options_menu = gtk.Menu()
	
        #Add configure item
	configure_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_preferences'))
	configure_image = gtk.Image()
	configure_image.set_from_file('%s/preferences.png' % self.nametheme) 
	configure_item.set_image(configure_image)
	configure_item.connect('activate', winpreferences.winshow, self.destroyw, self.delete_event, self.languageconfig, self.globalconfig, self.nametheme, win)

	options_menu.append(configure_item)
	
	#Actions menu
	act_menu = gtk.Menu()
	
        #Add scan item
	scan_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_scan'))
	scan_image = gtk.Image()
	scan_image.set_from_file('%s/scan_now_small.png' % self.nametheme)
	scan_item.set_image(scan_image)
	scan_item.connect('activate', winscan.winshow, self.destroyw, self.delete_event, self.languageconfig, self.globalconfig, self.defconfig, self.nametheme, win)
	
        #Add update item
	update_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_update'))
	update_image = gtk.Image()
	update_image.set_from_file('%s/update.png' % self.nametheme)
	update_item.set_image(update_image)
	update_item.connect('activate', winupdate.winshow, self.destroyw, self.delete_event, self.languageconfig, self.globalconfig, self.nametheme, win, self.defconfig)
        
        #Add eventlog item
        evlog_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_eventlog'))
	evlog_image = gtk.Image()
	evlog_image.set_from_file('%s/eventlog.png' % self.nametheme)
	evlog_item.set_image(evlog_image)
	evlog_item.connect('activate', wineventlog.winshow, self.destroyw, self.delete_event, self.languageconfig, self.nametheme, win)
	
	act_menu.append(scan_item)
	act_menu.append(update_item)
        act_menu.append(evlog_item)
	
	#Help menu
	help_menu = gtk.Menu()
	
        #Add about item
	about_item = gtk.ImageMenuItem(self.languageconfig.get('MAINWINDOW','menu_about'))
	about_image = gtk.Image()
	about_image.set_from_file('%s/info.png' % self.nametheme)
	about_item.set_image(about_image)
	about_item.connect('activate', winabout.winshow, self.destroyw, self.delete_event, self.languageconfig, self.nametheme, win)
	
	help_menu.append(about_item)
	
	#Add menus
	menu_bar = gtk.MenuBar()
	
	file_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_file'))
        file_item.set_submenu(file_menu)
	
	options_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_options'))
	options_item.set_submenu(options_menu)
	
	act_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_act'))
	act_item.set_submenu(act_menu)
	
	about_item = gtk.MenuItem(self.languageconfig.get('MAINWINDOW','menu_item_help'))
	about_item.set_submenu(help_menu)
	
	menu_bar.append(file_item)
	menu_bar.append(options_item)
	menu_bar.append(act_item)
        menu_bar.append(about_item)
	
	
	#show
	indextable.attach(menu_bar, 0, 3, 0, 1, gtk.FILL, gtk.FILL)
	indextable.attach(treeview, 0, 3, 1, 2, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL)
	indextable.attach(buttonsbox, 0, 1, 2, 3, 0 , 0)
	indextable.attach(status, 1, 3, 2, 3, gtk.EXPAND|gtk.FILL , 0)
	indextable.attach(nixstatusbar, 0, 3, 3, 4, gtk.FILL, gtk.FILL)
	win.add(indextable)
	win.show_all()
	
	#Focus
	win.set_focus(None)

        #Print execution time
	if '-debug' in argv:
            print 'Executed in ' + str(time() - timen) + ' seconds'
        
    def event_occ(self, widget, event, *items):
        #If global configuration has changed, update it
        if not stat('etc/gconfig.cfg').st_mtime == self.lstime:
            self.lstime = stat('etc/gconfig.cfg').st_mtime
            self.globalconfig.read('etc/gconfig.cfg')
            #print 'Updated gconfig!'

            #Update stat list
            global liststore, globalconfig
            liststore.set_value(liststore.get_iter(0), 1, int(self.globalconfig.get('GENERAL','num_scans')))
            liststore.set_value(liststore.get_iter(1), 1, int(self.globalconfig.get('GENERAL','num_found_obj')))
            liststore.set_value(liststore.get_iter(2), 1, int(self.globalconfig.get('GENERAL','num_removed_obj')))
            liststore.set_value(liststore.get_iter(3), 1, int(self.globalconfig.get('GENERAL','num_hfound_obj')))
            liststore.set_value(liststore.get_iter(4), 1, int(self.globalconfig.get('GENERAL','num_mfound_obj')))
            liststore.set_value(liststore.get_iter(5), 1, int(self.globalconfig.get('GENERAL','num_lfound_obj')))
            liststore.set_value(liststore.get_iter(6), 1, int(self.globalconfig.get('GENERAL','num_ifound_obj')))
            
        if not stat('etc/black_list.cfg').st_mtime == self.lstime2:
            self.lstime2 = stat('etc/black_list.cfg').st_mtime
            self.defconfig.read('etc/black_list.cfg')
            nixstatusbar.push(1, (':'*3) + self.languageconfig.get('MAINWINDOW','database_status') + ' ' + self.defconfig.get('INFO','version') + ' (' + self.defconfig.get('INFO','date') + ')')
            #print 'Updated black list!'
            
    
    def main(self):
        gtk.main()
        
    def delete_event(self, widget, event, data=None):
        return False
        
    def destroyw(self, widget, window=None):
        if window:
            window.hide()
        print 'Shutting down..'
        gtk.main_quit()

        

if __name__ == '__main__':
    #Start main application
    loop = indexWindow()
    loop.main()
