import pygtk, gtk
from os import path, mkdir, listdir, remove
from pango import ELLIPSIZE_END
from zipfile import ZipFile, is_zipfile
from shutil import move, rmtree
from winmodules import *

def winshow(widget, destroyw, delete_event, languageconfig, globalconfig, nametheme, trwin):

    
    def save_changes(widget, trwin):
        #Save all changes into variables
        print 'Saving changes...'
        global language_id
        global theme_id
        
        globalconfig.set('PREFERENCES','ign_high', int(checkh.get_active()))
        globalconfig.set('PREFERENCES','ign_med', int(checkm.get_active()))
        globalconfig.set('PREFERENCES','ign_low', int(checkl.get_active()))
        globalconfig.set('PREFERENCES','heur_ac', int(checkhe.get_active()))
        globalconfig.set('USER','language_id',language_id)
        globalconfig.set('USER','theme',theme_id)
        
        #Save profiles
        it = liststore.get_iter_first()
        globalconfig.set('USER','profiles','')
        
        #Get names and paths
        while it:
          globalconfig.set('USER','profiles', globalconfig.get('USER','profiles') + liststore.get_value(it,1) + '|' + liststore.get_value(it,2) + '||')
          it = liststore.iter_next(it)
          
        #Save languages
        it = liststorelang.get_iter_first()
        globalconfig.set('USER','language_list','')
        
        #Get names and paths
        while it:
          globalconfig.set('USER','language_list', globalconfig.get('USER','language_list') + liststorelang.get_value(it,3) + ';')
          it = liststorelang.iter_next(it)
        globalconfig.set('USER','language_list', globalconfig.get('USER','language_list')[:-1])

        #Save themes
        it = liststoretheme.get_iter_first()
        globalconfig.set('USER','theme_list','')
        
        #Get names and paths
        while it:
          globalconfig.set('USER','theme_list', globalconfig.get('USER','theme_list') + liststoretheme.get_value(it,3) + ';')
          it = liststoretheme.iter_next(it)
        globalconfig.set('USER','theme_list', globalconfig.get('USER','theme_list')[:-1])
        
        #Save scan log settings
        globalconfig.set('PREFERENCES', 'wrlog', int(wrlog.get_active()))
        globalconfig.set('PREFERENCES', 'wrdet', int(wrdet.get_active()))
        globalconfig.set('PREFERENCES', 'wrback', int(wrbackup.get_active()))
        globalconfig.set('PREFERENCES', 'max_logs', int(adjustment.get_value()))

        #Rewrite configuration
        globalconfig.write(open('etc/gconfig.cfg','w'))
        gtk.Widget.destroy(trwin)
        
    
    def add_profile(widget):
        #File chooser
        filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = unicode(filebrowser.get_filename())
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_1'), win, languageconfig.get('PRWINDOW','error_title'))
            elif not "HTTP Cookie File" in open(selected, 'r').readline():
                show_error(languageconfig.get('PRWINDOW','error_2'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                it = liststore.get_iter_first()
                while it:
                    if liststore.get_value(it,2) != selected:
                       it = liststore.iter_next(it)
                    else:
                       show_error(languageconfig.get('PRWINDOW','error_6'), win, languageconfig.get('PRWINDOW','error_title'))
                       break
                else:
                     make_profilelist(None, 1, (path.basename(path.dirname(selected)), selected))
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()
        
    def add_languagetheme(widget, destdir, type):
        #File chooser
        if type == 0:
            filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title_lang') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
        else:
            filebrowser = gtk.FileChooserDialog(languageconfig.get('PRWINDOW', 'FileChooser_title_theme') , None, gtk.FILE_CHOOSER_ACTION_OPEN, (gtk.STOCK_APPLY, gtk.RESPONSE_ACCEPT, gtk.STOCK_CANCEL, gtk.RESPONSE_REJECT))
            
        filebrowser.set_transient_for(win)
        filebrowser.set_modal(True)
        filebrowser.set_show_hidden(True)
        filter = gtk.FileFilter()
        filter.add_pattern("*")
        filebrowser.add_filter(filter)
        response = filebrowser.run()
        
        #Get user response
        if response == gtk.RESPONSE_ACCEPT:
            selected = filebrowser.get_filename()
            
            #Check validity
            if not path.exists(selected):
                show_error(languageconfig.get('PRWINDOW','error_1'), win, languageconfig.get('PRWINDOW','error_title'))
            elif not is_zipfile(selected):
                show_error(languageconfig.get('PRWINDOW','error_3'), win, languageconfig.get('PRWINDOW','error_title'))
            else:
                ziparch = ZipFile(selected, 'r')
                if not ziparch.testzip():
                    #Is a valid archive
                    #Check for files
                    if type == 0:
                        files = ['langconf.cfg','FILEINFO','flag.png']
                    if type == 1:
                        files = ['add_new.png', 'apply.png', 'clear.png', 'connect.png', 'database.png', 'database_date.png', 'database_id.png', 'deny.png', 'dmfind.png', 'dmhigh.png', 'dmignored.png', 'dmlow.png', 'dmmed.png', 'dmpot.png', 'error_big.png', 'eventlog.png', 'FILEINFO', 'finish.png', 'folder.png', 'folder_up.png', 'found_obj.png', 'hfound_obj.png', 'icon.png', 'ifound_obj.png', 'info.png', 'info_big.png', 'lfound_obj.png', 'lst_update.png', 'mfound_obj.png', 'nixory_icon.png', 'nixory_icon_full.png', 'object.png', 'object_risk.png', 'ocheck.png', 'opt_f.png', 'opt_s.png', 'preferences.png', 'profile.png', 'quit.png', 'removed_obj.png', 'remove_sel.png', 'risk_folder.png', 'rmtool.png', 'scans.png', 'scan_now.png', 'scan_now_small.png', 'select_all.png', 'server.png', 'set_default.png', 'signal.png', 'start_scan.png', 'tab_remove.png', 'tab_scan.png', 'tab_signal.png', 'update.png', 'warning.png']
                    valid = True
                    missing = ''
                    archfiles = ziparch.namelist()
                    
                    for name in files:
                        if not name in archfiles:
                            valid = False
                            missing += name + ', '
                        else:
                            pass
                        
                    if valid:
                        #Valid theme/language archive
                        
                        #Check if language/theme already exists
                        tmp_id = ziparch.read('FILEINFO').split(';')[2]
                        if not path.exists('%s/%s' % (destdir, tmp_id)) and not path.exists('%s/%s' % ('tmp/', tmp_id)):
                            #Create language/theme directory
                            mkdir('%s/%s' % ('tmp/', tmp_id), 777)
                            
                            #Extract all files
                            for name in archfiles:
                                print 'Extracting %s...' % name
                                wrtfile = open('%s/%s/%s' % ('tmp/', tmp_id, name), 'wb')
                                wrtfile.write(ziparch.read(name))
                                wrtfile.close()
                            #Write tmp file
                            tmpf = open('tmp/%s/TMP' % (tmp_id), 'w')
                            tmpf.write('w;rm')
                            tmpf.close()
                            
                            if type == 0:
                                name_new_lang = make_languagelist(None, True, tmp_id) 
                                print name_new_lang + ' language support successfully added'
                            else:
                                name_new_theme = make_themelist(None, True, tmp_id)
                                print name_new_theme + ' theme support successfully added'
                            
                            
                        else:
                            show_error(languageconfig.get('PRWINDOW','error_6'), win, languageconfig.get('PRWINDOW','error_title'))
                            
                        
                        
                        
                    else:
                        show_error(languageconfig.get('PRWINDOW','error_5').replace('%missing', missing[:-2]), win, languageconfig.get('PRWINDOW','error_title'))
                          
                else:
                    show_error(languageconfig.get('PRWINDOW','error_4'), win, languageconfig.get('PRWINDOW','error_title'))
            
        if response == gtk.RESPONSE_REJECT:
            filebrowser.destroy()
        filebrowser.destroy()
    
    
    def make_profilelist(widget, refresh, new_profile=None):
        #If liststore has changed, update it...
        if refresh:
           liststore.append([gtk.gdk.pixbuf_new_from_file("%s/profile.png" % nametheme), new_profile[0], new_profile[1]])
        #Else make it all
        else:
            profilelist = globalconfig.get('USER','profiles')
            profilelist = profilelist.split('||')
            del profilelist[-1]
            for profile in profilelist:
                liststore.append([gtk.gdk.pixbuf_new_from_file("%s/profile.png" % nametheme), profile.split('|')[0], profile.split('|')[1]])

    def make_languagelist(widget, refresh=False, new_language=None):
        if not refresh:
            #Detect all installed languages
            if globalconfig.get('USER','language_list'):
              langlist = globalconfig.get('USER','language_list').split(';')
              for language in langlist:
                #Open language directory
                info = open('etc/lang/%s/FILEINFO' % language,'r').readline().split(';')
                liststorelang.append([gtk.gdk.pixbuf_new_from_file("etc/lang/%s/flag.png" % language),  info[0], info[1], language])
        else:
            info = open('tmp/%s/FILEINFO' % new_language,'r').readline().split(';')
            liststorelang.append([gtk.gdk.pixbuf_new_from_file("tmp/%s/flag.png" % new_language),  info[0], info[1], new_language])
            return info[0]

    def make_themelist(widget, refresh=False, new_theme=None):
        if not refresh:
            #Detect all installed themes
            if globalconfig.get('USER','theme_list'):
                themelist = globalconfig.get('USER','theme_list').split(';')
                for theme in themelist:
                    #Open theme directory
                    info = open('icons/%s/FILEINFO' % theme,'r').readline().split(';')
                    liststoretheme.append([gtk.gdk.pixbuf_new_from_file("icons/%s/icon.png" % theme),  info[0], info[1], theme])
        else:
            info = open('tmp/%s/FILEINFO' % new_theme,'r').readline().split(';')
            liststoretheme.append([gtk.gdk.pixbuf_new_from_file("tmp/%s/icon.png" % new_theme),  info[0], info[1], new_theme])
            return info[0]
    
    def cursor_changed(widget, type, *items):
        if type == 0:
            global cursorpos
            cursorpos = treeview.get_cursor()[0][0]
        elif type == 1:
            global cursorpos2
            cursorpos2 = treeviewlang.get_cursor()[0][0]
        elif type == 2:
            global cursorpos3
            cursorpos3 = treeviewtheme.get_cursor()[0][0]
        
    def remove_item(widget, type, *items):
        if type == 0:
            global cursorpos
        
            #Remove from liststore selected row
            if cursorpos != None:
                liststore.remove(liststore.get_iter(int(cursorpos)))
                cursorpos = None
        elif type == 1:
            global cursorpos2
            global language_id
        
            #Remove from liststore selected row
            if cursorpos2 != None:
                if liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3) != languageconfig.get('FILE','self_id') and language_id != liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3):
                    #Move language pack to tmp directory
                    if not path.exists('tmp/%s' % liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3)):
                        move('etc/lang/%s/' % liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3), 'tmp/%s' % liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3))
                        tmpf = open('tmp/%s/TMP' % liststorelang.get_value(liststorelang.get_iter(cursorpos2), 3), 'w')
                        tmpf.write('rm;w')
                        tmpf.close()                                
                    
                    #Remove row
                    liststorelang.remove(liststorelang.get_iter(int(cursorpos2)))
                    cursorpos2 = None
                    
                    
                else:
                    show_error(languageconfig.get('PRWINDOW','un_remove'), win, languageconfig.get('PRWINDOW','error_title'))
        elif type == 2:
            global cursorpos3
            global theme_id
            
            #Remove from liststore selected row
            if cursorpos3 != None:
                if 'icons/' + liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3) != nametheme and theme_id != liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3):
                    #Move theme pack to tmp directory
                    if not path.exists('tmp/%s' % liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3)):
                       move('icons/%s/' % liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3), 'tmp/%s' % liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3))
                       tmpf = open('tmp/%s/TMP' % liststoretheme.get_value(liststoretheme.get_iter(cursorpos3), 3), 'w')
                       tmpf.write('rm;w')
                       tmpf.close()
                    
                    liststoretheme.remove(liststoretheme.get_iter(int(cursorpos3)))
                    cursorpos3 = None
                else:
                    show_error(languageconfig.get('PRWINDOW','unm_remove'), win, languageconfig.get('PRWINDOW','error_title'))
            
    
    def setasdefault_item(widget, type, *items):
        #Set as default item
        if type == 0:
            global cursorpos2
            if cursorpos2 != None:
                #Get language info
                global language_id
                language_id =liststorelang.get_value(liststorelang.get_iter(int(cursorpos2)), 3)
                language_name =liststorelang.get_value(liststorelang.get_iter(int(cursorpos2)), 1)
            
                #Set new language id
                deflabel.set_text(languageconfig.get('PRWINDOW','def_label').replace('%lang', language_name))
            
                #Prompt user
                adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text').replace('%lang',language_name))
                adv.set_title(languageconfig.get('PRWINDOW','infodiag_title'))
                adv.set_modal(True)
                adv.set_transient_for(win)
                adv.show()
                resp = adv.run()
                if resp == gtk.RESPONSE_CLOSE:
                    adv.destroy()
                adv.destroy()
                
        if type == 1:
            global cursorpos3
            if cursorpos3 != None:
                #Get language info
                global theme_id
                theme_id =liststoretheme.get_value(liststoretheme.get_iter(int(cursorpos3)), 3)
                theme_name =liststoretheme.get_value(liststoretheme.get_iter(int(cursorpos3)), 1)
            
                #Set new language id
                deflabelm.set_text(languageconfig.get('PRWINDOW','def_labelm').replace('%theme', theme_name))
            
                #Prompt user
                adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_theme').replace('%theme',theme_name))
                adv.set_title(languageconfig.get('PRWINDOW','infodiag_title'))
                adv.set_modal(True)
                adv.set_transient_for(win)
                adv.show()
                resp = adv.run()
                if resp == gtk.RESPONSE_CLOSE:
                    adv.destroy()
                adv.destroy()
                
    def handle_tmp(widget, action, *items):
        #Read what to do for each file (action 0 = Apply, 1 = Cancel)
        if len(items) > 0:
            action = items[0]
        files = listdir('tmp/')
        for file in files:
            factions = open('tmp/%s/TMP' % file)
            actions = factions.read().split(';')
            factions.close()
            remove('tmp/%s/TMP' % file)

            #Write into destdir
            if actions[action] == 'w':
                if path.exists('tmp/%s/flag.png' % file):
                    if not path.exists('etc/lang/%s' % file):
                        move('tmp/%s' % file, 'etc/lang/%s' % file)
                    else:
                        pass
                else:
                    if not path.exists('icons/%s' % file):
                        move('tmp/%s' % file, 'icons/%s' % file)
                    else:
                        pass

            #Remove from tmp
            if actions[action] == 'rm':
                rmtree('tmp/%s' % file)
        
    def wrlog_togg(*items):
        #Toggle check buttons
        wrlog.get_active()
        wrdet.set_sensitive(wrlog.get_active())
        logs.set_sensitive(wrlog.get_active())
        
    def clear_log(*items):
        #Clear log
        #Save backup if needed
        if wrbackup.get_active():
            open('etc/scan_log.txt.bk','w').write(open('etc/scan_log.txt','r').read())
        logfile = open('etc/scan_log.txt','w')
        logfile.flush()
        logfile.close()
        
        #Info Dialog
        adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_INFO, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_log'))
        adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_log'))
        adv.set_modal(True)
        adv.set_transient_for(win)
        adv.show()
        resp = adv.run()
        if resp == gtk.RESPONSE_CLOSE:
            adv.destroy()
        adv.destroy()
        
    def heur_warning(*items):
        if checkhe.get_active():
           #Display warning
           adv = gtk.MessageDialog(None, 0, gtk.MESSAGE_WARNING, gtk.BUTTONS_CLOSE, languageconfig.get('PRWINDOW','infodiag_text_warning'))
           adv.set_title(languageconfig.get('PRWINDOW','infodiag_title_warning'))
           adv.set_modal(True)
           adv.set_transient_for(win)
           adv.show()
           resp = adv.run()
           if resp == gtk.RESPONSE_CLOSE:
              adv.destroy()
           adv.destroy()
        else:
            pass
        
    #Preference Window
    
    #Start Window
    win = gtk.Window(gtk.WINDOW_TOPLEVEL)
    win.connect("delete_event", handle_tmp, 1)
    win.connect("delete_event", delete_event)
    win.set_position(gtk.WIN_POS_CENTER)
    win.set_default_size(410, 305)
    win.set_resizable(True)
    win.set_title(languageconfig.get('PRWINDOW','window_title'))
    win.set_modal(True)
    win.set_transient_for(trwin)
    
    #Main Table
    maintable = gtk.Table(2, 2, False)
    
    #Notebook
    notebook = gtk.Notebook()
    notebook.set_tab_pos(gtk.POS_TOP)
    
    ##Scan Section
    ####
    
    #Section table
    prtable = gtk.Table(2, 4, False)
    
    #Scrolled window
    scrollwin = gtk.ScrolledWindow(None, None)
    scrollwin.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    
    #Tree liststore
    liststore = gtk.ListStore(gtk.gdk.Pixbuf, str, str)
    
    #TreeView
    treeview = gtk.TreeView(liststore)
    treeview.set_rules_hint(True)
    treeview.connect("cursor-changed",cursor_changed,0)
    
    
    #Make profile list
    global cursorpos
    cursorpos = None
    make_profilelist(None, False)

    #TreeViewColums
    columnpix = gtk.TreeViewColumn()
    columnstr = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_top'))
    columnstr2 = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','profile_path'))
    
    #Append columns
    treeview.append_column(columnpix)
    treeview.append_column(columnstr)
    treeview.append_column(columnstr2)

    #Cellrenderers
    cellpix = gtk.CellRendererPixbuf()
    cellstr = gtk.CellRendererText()
    cellstr.set_property("ellipsize-set", True)
    cellstr.set_property("ellipsize", ELLIPSIZE_END)
    cellstr2 = gtk.CellRendererText()
    cellstr2.set_property("ellipsize-set", True)
    cellstr2.set_property("ellipsize", ELLIPSIZE_END)

    #Add cell renderers
    columnpix.pack_start(cellpix, True)
    columnstr.pack_start(cellstr, True)
    columnstr.set_resizable(True)
    columnstr2.pack_start(cellstr2, True)

    #Set attributes
    columnpix.set_attributes(cellpix, pixbuf=0)
    columnstr.set_attributes(cellstr, text=1)
    columnstr2.set_attributes(cellstr2, text=2)
    cellpix.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Add TreeView to ScrolledWin
    scrollwin.add(treeview)

    #Label Profiles
    proflab = gtk.Label(' ' + languageconfig.get('PRWINDOW','label_profile'))
    
    #Remove profile button
    removebox = gtk.HBox(False, 0)
    removeimage = gtk.Image()
    removeimage.set_from_file('%s/clear.png' % nametheme)
    removelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','removepr_lab'))
    removebox.pack_start(removeimage, False, 1)
    removebox.pack_start(removelab, True, 1)
    removebut = gtk.Button()
    removebut.add(removebox)
    removebut.connect('clicked',remove_item, 0)
    
    #Add profile button
    addbox = gtk.HBox(False, 0)
    addimage = gtk.Image()
    addimage.set_from_file('%s/add_new.png' % nametheme)
    addlab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','addpr_lab'))
    addbox.pack_start(addimage, False, 1)
    addbox.pack_start(addlab, True, 1)
    addbut = gtk.Button()
    addbut.add(addbox)
    addbut.connect('clicked',add_profile)
    
    #Button box
    pbox = gtk.HBox(False, 0)
    pbox.pack_start(removebut, False, 1)
    pbox.pack_start(addbut, False, 1)
    
    #HSeparator
    sep = gtk.HSeparator()
    
    #Frame(Infections filter) Container
    frame = gtk.Frame(languageconfig.get('PRWINDOW','frame_label'))
    frame.set_label_align(0.9, 0.5)
    
    
    #Check buttons
    checkh = gtk.CheckButton(languageconfig.get('PRWINDOW','check_high'))
    checkh.set_active(int(globalconfig.get('PREFERENCES', 'ign_high')))
    checkm = gtk.CheckButton(languageconfig.get('PRWINDOW','check_medium'))
    checkm.set_active(int(globalconfig.get('PREFERENCES', 'ign_med')))
    checkl = gtk.CheckButton(languageconfig.get('PRWINDOW','check_low'))
    checkl.set_active(int(globalconfig.get('PREFERENCES', 'ign_low')))
    checkhe = gtk.CheckButton(languageconfig.get('PRWINDOW','check_heur'))
    checkhe.set_active(int(globalconfig.get('PREFERENCES', 'heur_ac')))
    checkhe.connect('toggled', heur_warning)
    
    #Check buttons VContainer
    vbox = gtk.VBox(False, 0)
    vbox.pack_start(checkh, False, 1)
    vbox.pack_start(checkm, False, 1)
    vbox.pack_start(checkl, False, 1)
    vbox.pack_start(checkhe, False, 1)
    
    #Add widgets -> frame
    frame.add(vbox)
                  
    #Attach elements
    prtable.attach(scrollwin, 0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL, 1)
    prtable.attach(proflab, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(pbox, 1, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(sep, 0, 2, 2, 3, gtk.EXPAND|gtk.FILL, 0)
    prtable.attach(frame, 0, 2, 3, 4, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanbox = gtk.HBox(False, 0)
    scanimage = gtk.Image()
    scanimage.set_from_file('%s/tab_scan.png' % nametheme)
    scanlab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scan_top'))
    scanimage.show()
    scanlab.show()
    scanbox.pack_start(scanimage, True, 1)
    scanbox.pack_start(scanlab, False, 1)
    
    ##Language Section
    ####
    
    
    #Section table
    sltable = gtk.Table(4, 2, False)
    
    #Scrolled window
    scrollwinsl = gtk.ScrolledWindow(None, None)
    scrollwinsl.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    
    #Tree liststore
    liststorelang = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
    
    #TreeView
    treeviewlang = gtk.TreeView(liststorelang)
    treeviewlang.set_rules_hint(True)
    treeviewlang.connect("cursor-changed",cursor_changed,1)
    
    #Make language list
    global cursorpos2
    global language_id
    language_id = globalconfig.get('USER','language_id')
    cursorpos2 = None
    make_languagelist(None)

    #TreeViewColums
    columnpixl = gtk.TreeViewColumn(None)
    columnstrl = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','language_name') + ' '*10)
    columnstr2l = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','language_author'))
    columnstr3l = gtk.TreeViewColumn(None)
    columnstr3l.set_visible(False)
    
    #Append columns
    treeviewlang.append_column(columnpixl)
    treeviewlang.append_column(columnstrl)
    treeviewlang.append_column(columnstr2l)
    treeviewlang.append_column(columnstr3l)

    #Cellrenderers
    cellpixl = gtk.CellRendererPixbuf()
    cellstrl = gtk.CellRendererText()
    cellstrl.set_property("ellipsize-set", True)
    cellstrl.set_property("ellipsize", ELLIPSIZE_END)
    cellstr2l = gtk.CellRendererText()
    cellstr2l.set_property("ellipsize-set", True)
    cellstr2l.set_property("ellipsize", ELLIPSIZE_END)
    cellstr3l = gtk.CellRendererText()

    #Add cell renderers
    columnpixl.pack_start(cellpixl, True)
    columnstrl.pack_start(cellstrl, True)
    columnstrl.set_resizable(True)
    columnstr2l.pack_start(cellstr2l, True)
    columnstr3l.pack_start(cellstr3l, True)

    #Set attributes
    columnpixl.set_attributes(cellpixl, pixbuf=0)
    columnstrl.set_attributes(cellstrl, text=1)
    columnstr2l.set_attributes(cellstr2l, text=2)
    columnstr3l.set_attributes(cellstr3l, text=3)
    cellpixl.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Add TreeView to ScrolledWin
    scrollwinsl.add(treeviewlang)
    
    #Add new language button
    addnewbox = gtk.HBox(False, 0)
    addnewimage = gtk.Image()
    addnewimage.set_from_file('%s/add_new.png' % nametheme)
    addnewlab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','addpr_lab'))
    addnewbox.pack_start(addnewimage, False, 1)
    addnewbox.pack_start(addnewlab, True, 1)
    addnewbut = gtk.Button()
    addnewbut.add(addnewbox)
    addnewbut.connect('clicked',add_languagetheme, 'etc/lang', 0)
    
    #Remove language button
    remlangbox = gtk.HBox(False, 0)
    remlangimage = gtk.Image()
    remlangimage.set_from_file('%s/clear.png' % nametheme)
    remlanglab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','removepr_lab'))
    remlangbox.pack_start(remlangimage, False, 1)
    remlangbox.pack_start(remlanglab, True, 1)
    remlangbut = gtk.Button()
    remlangbut.add(remlangbox)
    remlangbut.connect('clicked',remove_item, 1)
    
    #Set default language button
    deflangbox = gtk.HBox(False, 0)
    deflangimage = gtk.Image()
    deflangimage.set_from_file('%s/set_default.png' % nametheme)
    deflanglab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','defaultlg_lab'))
    deflangbox.pack_start(deflangimage, False, 1)
    deflangbox.pack_start(deflanglab, True, 1)
    deflangbut = gtk.Button()
    deflangbut.add(deflangbox)
    deflangbut.connect('clicked',setasdefault_item, 0)
    
    #Button box
    lgbox = gtk.HBox(False, 0)
    lgbox.pack_start(addnewbut, False, 1)
    lgbox.pack_start(remlangbut, False, 1)
    lgbox.pack_start(deflangbut, False, 1)
    
    #Label
    deflabel = gtk.Label(languageconfig.get('PRWINDOW','def_label').replace('%lang', open('etc/lang/%s/FILEINFO' % globalconfig.get('USER','language_id'),'r').readline().split(';')[0]))
    deflabel.set_ellipsize(ELLIPSIZE_END)
     
    #Attach elements
    sltable.attach(scrollwinsl, 0, 4, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL, 1)
    sltable.attach(lgbox, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    sltable.attach(deflabel, 1, 4, 1, 2, gtk.EXPAND|gtk.FILL, 0)

    #Language label box
    langbox = gtk.HBox(False, 0)
    langimage = gtk.Image()
    langimage.set_from_file('%s/tab_scan.png' % nametheme)
    langlab = gtk.Label(' ' + languageconfig.get('PRWINDOW','language_top'))
    langimage.show()
    langlab.show()
    langbox.pack_start(langimage, True, 1)
    langbox.pack_start(langlab, False, 1)

    ##Themes Section
    ####
    
    
    #Section table
    smtable = gtk.Table(4, 2, False)
    
    #Scrolled window
    scrollwinsm = gtk.ScrolledWindow(None, None)
    scrollwinsm.set_policy(gtk.POLICY_NEVER, gtk.POLICY_ALWAYS)
    
    #Tree liststore
    liststoretheme = gtk.ListStore(gtk.gdk.Pixbuf, str, str, str)
    
    #TreeView
    treeviewtheme = gtk.TreeView(liststoretheme)
    treeviewtheme.set_rules_hint(True)
    treeviewtheme.connect("cursor-changed",cursor_changed,2)
    
    #Make language list
    global cursorpos3
    global theme_id
    theme_id = globalconfig.get('USER','theme')
    cursorpos3 = None
    make_themelist(None)

    #TreeViewColums
    columnpixm = gtk.TreeViewColumn(None)
    columnstrm = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','theme_name') + ' '*10)
    columnstr2m = gtk.TreeViewColumn(languageconfig.get('PRWINDOW','theme_author'))
    columnstr3m = gtk.TreeViewColumn(None)
    columnstr3m.set_visible(False)
    
    #Append columns
    treeviewtheme.append_column(columnpixm)
    treeviewtheme.append_column(columnstrm)
    treeviewtheme.append_column(columnstr2m)
    treeviewtheme.append_column(columnstr3m)

    #Cellrenderers
    cellpixm = gtk.CellRendererPixbuf()
    cellstrm = gtk.CellRendererText()
    cellstrm.set_property("ellipsize-set", True)
    cellstrm.set_property("ellipsize", ELLIPSIZE_END)
    cellstr2m = gtk.CellRendererText()
    cellstr2m.set_property("ellipsize-set", True)
    cellstr2m.set_property("ellipsize", ELLIPSIZE_END)
    cellstr3m = gtk.CellRendererText()

    #Add cell renderers
    columnpixm.pack_start(cellpixm, True)
    columnstrm.pack_start(cellstrm, True)
    columnstrm.set_resizable(True)
    columnstr2m.pack_start(cellstr2m, True)
    columnstr3m.pack_start(cellstr3m, True)

    #Set attributes
    columnpixm.set_attributes(cellpixm, pixbuf=0)
    columnstrm.set_attributes(cellstrm, text=1)
    columnstr2m.set_attributes(cellstr2m, text=2)
    columnstr3m.set_attributes(cellstr3m, text=3)
    cellpixm.set_property('stock-size', gtk.ICON_SIZE_LARGE_TOOLBAR)
    
    #Add TreeView to ScrolledWin
    scrollwinsm.add(treeviewtheme)
    
    #Add new theme button
    addnewboxm = gtk.HBox(False, 0)
    addnewimagem = gtk.Image()
    addnewimagem.set_from_file('%s/add_new.png' % nametheme)
    addnewlabm = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','addpr_lab'))
    addnewboxm.pack_start(addnewimagem, False, 1)
    addnewboxm.pack_start(addnewlabm, True, 1)
    addnewbutm = gtk.Button()
    addnewbutm.add(addnewboxm)
    addnewbutm.connect('clicked',add_languagetheme, 'icons', 1)
    
    #Remove theme button
    remthemebox = gtk.HBox(False, 0)
    remthemeimage = gtk.Image()
    remthemeimage.set_from_file('%s/clear.png' % nametheme)
    remthemelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','removepr_lab'))
    remthemebox.pack_start(remthemeimage, False, 1)
    remthemebox.pack_start(remthemelab, True, 1)
    remthemebut = gtk.Button()
    remthemebut.add(remthemebox)
    remthemebut.connect('clicked',remove_item, 2)
    
    #Set default theme button
    defthemebox = gtk.HBox(False, 0)
    defthemeimage = gtk.Image()
    defthemeimage.set_from_file('%s/set_default.png' % nametheme)
    defthemelab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','defaultlg_lab'))
    defthemebox.pack_start(defthemeimage, False, 1)
    defthemebox.pack_start(defthemelab, True, 1)
    defthemebut = gtk.Button()
    defthemebut.add(defthemebox)
    defthemebut.connect('clicked',setasdefault_item, 1)
    
    #Button box
    lgboxm = gtk.HBox(False, 0)
    lgboxm.pack_start(addnewbutm, False, 1)
    lgboxm.pack_start(remthemebut, False, 1)
    lgboxm.pack_start(defthemebut, False, 1)
    
    #Label
    deflabelm = gtk.Label(languageconfig.get('PRWINDOW','def_labelm').replace('%theme', open('icons/%s/FILEINFO' % theme_id,'r').readline().split(';')[0]))
    deflabelm.set_ellipsize(ELLIPSIZE_END)
     
    #Attach elements
    smtable.attach(scrollwinsm, 0, 4, 0, 1, gtk.EXPAND|gtk.FILL, gtk.EXPAND|gtk.FILL, 1)
    smtable.attach(lgboxm, 0, 1, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    smtable.attach(deflabelm, 1, 4, 1, 2, gtk.EXPAND|gtk.FILL, 0)

    #Themes label box
    themebox = gtk.HBox(False, 0)
    themeimage = gtk.Image()
    themeimage.set_from_file('%s/tab_scan.png' % nametheme)
    themelab = gtk.Label(' ' + languageconfig.get('PRWINDOW','theme_top'))
    themeimage.show()
    themelab.show()
    themebox.pack_start(themeimage, True, 1)
    themebox.pack_start(themelab, False, 1)
    
    
    ##Scan Log Section
    ####
    
    #Table
    scanlogtable = gtk.Table(3, 9, False)
    
    #Labels
    spaces = gtk.HSeparator()
    spaces2 = gtk.Label('\n')
    scanmax = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanmax_log') + ' '*3)
    
    #CheckButtons
    wrlog = gtk.CheckButton(languageconfig.get('PRWINDOW','wrlog'))
    wrlog.set_active(int(globalconfig.get('PREFERENCES','wrlog')))
    wrlog.connect('toggled',wrlog_togg)
    wrdet = gtk.CheckButton(languageconfig.get('PRWINDOW','wrdet'))
    wrdet.set_active(int(globalconfig.get('PREFERENCES','wrdet')))
    wrbackup = gtk.CheckButton(languageconfig.get('PRWINDOW','wrback'))
    wrbackup.set_active(int(globalconfig.get('PREFERENCES','wrback')))
    
    #HScale and adjustment
    adjustment = gtk.Adjustment(float(globalconfig.get('PREFERENCES', 'max_logs')), 1, 50, 0, 0, 0)
    logs = gtk.HScale(adjustment)
    logs.set_digits(0)
    
    #Toggle check buttons
    wrlog_togg()
    
    #Separators
    hssep = gtk.HSeparator()
    
    #Box Button Clear Log
    clearlbox = gtk.HBox(False, 0)
    clearlimage = gtk.Image()
    clearlimage.set_from_file('%s/clear.png' % nametheme)
    clearllab = gtk.Label(' ' + languageconfig.get('PRWINDOW','clear_log'))
    clearlbox.pack_start(clearlimage, False, 1)
    clearlbox.pack_start(clearllab, True, 1)
    clearlbut = gtk.Button()
    clearlbut.add(clearlbox)
    clearlbut.connect('clicked', clear_log)
    
    #Button box
    pppbox = gtk.HBox(False, 0)
    pppbox.pack_start(clearlbut, False, 1)
    
    #Attach
    scanlogtable.attach(spaces ,0, 3, 0, 1, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrlog ,0, 3, 1, 2, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrdet ,0, 3, 2, 3, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(wrbackup ,0, 3, 3, 4, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(spaces2 ,0, 3, 4, 5, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(logs ,2, 3, 5, 6, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(scanmax ,0, 2, 5, 6, gtk.FILL|gtk.FILL, 0)
    scanlogtable.attach(hssep ,0, 3, 6, 7, gtk.EXPAND|gtk.FILL, 0)
    scanlogtable.attach(pppbox ,0, 3, 7, 8, gtk.EXPAND|gtk.FILL, 0)
    
    #Scan label box
    scanlogbox = gtk.HBox(False, 0)
    scanlogimage = gtk.Image()
    scanlogimage.set_from_file('%s/tab_scan.png' % nametheme)
    scanloglab = gtk.Label(' ' + languageconfig.get('PRWINDOW','scanlog_top'))
    scanlogimage.show()
    scanloglab.show()
    scanlogbox.pack_start(scanlogimage, True, 1)
    scanlogbox.pack_start(scanloglab, False, 1)
    
    #Append pages
    notebook.append_page(prtable, scanbox)
    notebook.append_page(sltable, langbox)
    notebook.append_page(smtable, themebox)
    notebook.append_page(scanlogtable, scanlogbox)
    
    #Buttons
    #Box Button Apply
    applybox = gtk.HBox(False, 0)
    applyimage = gtk.Image()
    applyimage.set_from_file('%s/apply.png' % nametheme)
    applylab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','apply_lab'))
    applybox.pack_start(applyimage, False, 1)
    applybox.pack_start(applylab, True, 1)
    applybut = gtk.Button()
    applybut.add(applybox)
    applybut.connect('clicked', handle_tmp, win, 0)
    applybut.connect('clicked', save_changes, win)
   
    
    #Box Button Cancel
    cancbox = gtk.HBox(False, 0)
    cancimage = gtk.Image()
    cancimage.set_from_file('%s/deny.png' % nametheme)
    canclab = gtk.Label(' '*2 + languageconfig.get('PRWINDOW','cancel_lab'))
    cancbox.pack_start(cancimage, False, 1)
    cancbox.pack_start(canclab, True, 1)
    cancbut = gtk.Button()
    cancbut.add(cancbox)
    cancbut.connect("clicked", handle_tmp, 1)
    cancbut.connect_object("clicked", gtk.Widget.destroy, win)
    
    #Button box
    ppbox = gtk.HBox(False, 0)
    ppbox.pack_start(applybut, False, 1)
    ppbox.pack_start(cancbut, False, 1)
    
    #Attach
    maintable.attach(notebook ,0, 2, 0, 1, gtk.EXPAND|gtk.FILL, gtk.FILL|gtk.EXPAND, 1)
    maintable.attach(ppbox ,0, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0)
    
    
    win.add(maintable)
    win.show_all()
    
